/*--------------------------------------------------------------*
 |								|
 |  Waver  various constructors (C)GGENS (GPU) start 24.12.97	|
 |								|
 *--------------------------------------------------------------*/

#include <qlabel.h>
#include <qpainter.h>
#include <kiconloader.h>
#include <qpushbt.h>
#include <qcolor.h>


Wgui::Wgui( const char *name )
   : KTopLevelWidget ( name )
{
  setMinimumSize( 400, 330 );
  optLoad();

  lastLoadWaves = new QPopupMenu;
  updateLW();

  file = new QPopupMenu;
  file->insertItem( klocale->translate( "Open" ), ID_FILE_OPEN );
  file->insertItem( klocale->translate( "Reload" ), ID_FILE_RELOAD );
  file->insertItem( klocale->translate( "Open Recent..."), lastLoadWaves );
  file->insertItem( klocale->translate( "Save" ), ID_FILE_SAVE );
  file->insertItem( klocale->translate( "Save As" ), ID_FILE_SAVEAS );
  file->insertSeparator();
  file->insertItem( klocale->translate( "Quit" ), ID_FILE_QUIT );
  edit = new QPopupMenu;
  edit->insertItem( klocale->translate( "Copy" ), ID_EDIT_COPY );
  edit->insertItem( klocale->translate( "Cut" ), ID_EDIT_CUT );
  edit->insertItem( klocale->translate( "Paste" ), ID_EDIT_PASTE );
  edit->insertItem( klocale->translate( "Paste (mix)" ), ID_EDIT_PASTEMIX );
  edit->insertItem( klocale->translate( "Insert file" ), ID_EDIT_INSERT );
  edit->insertItem( klocale->translate( "Insert file(mix)" ), ID_EDIT_INSERTM );
  wplay = new QPopupMenu;
  wplay->insertItem( klocale->translate( "Play" ), ID_PLAY_PLAY );
  wplay->insertItem( klocale->translate( "Pause" ), ID_PLAY_PAUSE );
  wplay->insertItem( klocale->translate( "Stop" ), ID_PLAY_STOP );
  wplay->insertItem( klocale->translate( "Record" ), ID_PLAY_REC );
  wplay->insertSeparator();
  wplay->insertItem( klocale->translate( "Mixer" ), ID_PLAY_MIXER );
  wplay->insertItem( klocale->translate( "Recorder options" ), ID_PLAY_RECOPT );
  tools = new QPopupMenu;
  tools->insertItem( klocale->translate( "konvert format" ), ID_TOOLS_FORMATK );
  tools->insertItem( klocale->translate( "change frequency" ), ID_TOOLS_CHNGFRQ);
  tools->insertItem( klocale->translate( "invert wave" ), ID_TOOLS_INVERT);
  effects = new QPopupMenu;
  effects->insertItem( klocale->translate( "Hall" ), ID_EFFECTS_HALL );
  effects->insertItem( klocale->translate( "Loudness" ), ID_EFFECTS_LOUDNESS );
  effects->insertItem( klocale->translate( "Reverse" ), ID_EFFECTS_REVERSE );
  effects->insertItem( klocale->translate( "Fade in" ), ID_EFFECTS_FADEIN );
  effects->insertItem( klocale->translate( "Fade out" ), ID_EFFECTS_FADEOUT );
  effects->insertSeparator();
  effects->insertItem( klocale->translate( "Turn from left to rigth" ), ID_EFFECTS_TURNLR );
  effects->insertItem( klocale->translate( "Turn from rigth to left" ), ID_EFFECTS_TURNRL );
  options = new QPopupMenu;
  options->insertItem( klocale->translate( "Color" ), ID_OPTIONS_COLOR );
  options->insertItem( klocale->translate( "Save options" ), ID_OPTIONS_SAVE );
  help = new QPopupMenu;
  help->insertItem( klocale->translate( "Help" ), ID_HELP_HELP );
  help->insertItem( klocale->translate( "About" ), ID_HELP_ABOUT );
  connect (file, SIGNAL( activated ( int ) ), SLOT( menuCallback ( int ) ) );
  connect (lastLoadWaves, SIGNAL( activated ( int ) ), SLOT( menuCallback ( int ) ) );
  connect (edit, SIGNAL( activated ( int ) ), SLOT( menuCallback ( int ) ) );
  connect (wplay, SIGNAL( activated ( int ) ), SLOT( menuCallback ( int ) ) );
  connect (tools, SIGNAL( activated ( int ) ), SLOT( menuCallback ( int ) ) );
  connect (effects, SIGNAL( activated ( int ) ), SLOT( menuCallback ( int ) ) );
  connect (options, SIGNAL( activated ( int ) ), SLOT( menuCallback ( int ) ) );
  connect (help, SIGNAL( activated ( int ) ), SLOT( menuCallback ( int ) ) );
  menu = new KMenuBar( this );
  CHECK_PTR( menu );
  menu->insertItem( klocale->translate( "&File" ), file );
  menu->insertItem( klocale->translate( "&Edit" ), edit );
  menu->insertItem( klocale->translate( "&Play" ), wplay );
  menu->insertItem( klocale->translate( "&Tools" ), tools );
  menu->insertItem( klocale->translate( "Effe&cts" ), effects );
  menu->insertItem( klocale->translate( "&Options" ), options );
  menu->insertSeparator();
  menu->insertItem( klocale->translate( "&Help" ), help );
  menu->show();
  setMenu(menu);
  wplay->setItemEnabled( ID_PLAY_STOP, FALSE );
  wplay->setItemEnabled( ID_PLAY_PAUSE, FALSE );
  effects->setItemEnabled( ID_EFFECTS_TURNLR, FALSE );
  effects->setItemEnabled( ID_EFFECTS_TURNRL, FALSE );
  KIconLoader *loader = kapp->getIconLoader();
  toolbar = new KToolBar( this );
  toolbar->insertButton( loader->loadIcon( "fileopen.xpm" ), ID_FILE_OPEN, TRUE,
	"Open a file");
  toolbar->insertButton( loader->loadIcon( "filefloppy.xpm" ), ID_FILE_SAVE, TRUE,
	klocale->translate( "Save the file" ));
  toolbar->insertButton( loader->loadIcon( "reload.xpm" ), ID_FILE_RELOAD, TRUE,
	klocale->translate( "Load file again form disk" ));
  toolbar->insertSeparator();
  toolbar->insertButton( loader->loadIcon( "editcopy.xpm" ), ID_EDIT_COPY, TRUE,
	klocale->translate( "copy selected area" ));
  toolbar->insertButton( loader->loadIcon( "editpaste.xpm" ), ID_EDIT_PASTE, TRUE,
	klocale->translate( "paste to your markpoint" ));
  toolbar->insertButton( loader->loadIcon( "editcut.xpm" ), ID_EDIT_CUT, TRUE,
	klocale->translate( "cut selected area" ));
  toolbar->insertSeparator();
  toolbar->insertButton( loader->loadIcon( "play.xpm" ), ID_PLAY_PLAY, TRUE,
	klocale->translate( "Play Wave" ));
  toolbar->insertButton( loader->loadIcon( "pause.xpm" ), ID_PLAY_PAUSE, TRUE,
	klocale->translate( "Pause Wave" ));
  toolbar->insertButton( loader->loadIcon( "stop.xpm" ), ID_PLAY_STOP, TRUE,
	klocale->translate( "Stop Wave" ));
  addToolBar(toolbar);
  toolbar->show();
  connect( toolbar, SIGNAL( clicked( int ) ), this, SLOT( menuCallback( int ) ) );
  stat = new KStatusBar(this);
  stat->insertItem( " Stereo ", ID_STAT_MONSTER );
  stat->insertItem( " 44100 Hz ", ID_STAT_SAMPLE );
  stat->insertItem( " 16 Bit ", ID_STAT_BIT );
  stat->insertItem( " 00000 kB ", ID_STAT_SIZE );
  stat->insertItem( " 000.0 sec ", ID_STAT_TIME );
  stat->show();
  setStatusBar(stat);

  paint = new QPainter ( this );

  pWavef=0;
  startMark=0;
  endMark=0;
  directory="";

  dropZone = new KDNDDropZone( this , DndURL );
  connect( dropZone, SIGNAL( dropAction( KDNDDropZone *) ),
           this, SLOT( dropEvent( KDNDDropZone *) ) );   

}

Wgui::~Wgui()
{
 system("rm /tmp/kwav-clipboard.wav &");
 paint->end();
}

Wave::Wave()
{
 loaded=0;
 Size=0;
 bit=8;
 Sampling=11025;
 NumSamples=1000;
 Channels=1;
 currPlayPos=0;
 playActive=0;
 buffer_size=256;
}

Wave::~Wave()
{
 freemem();
}

konvFormat::konvFormat( QWidget *parent, const char *name )
        : QDialog( parent, name, TRUE )
{

 setMinimumSize( 200, 300 );
 setMaximumSize( 200, 300 );
 QPushButton *ok, *cancel;
 ok = new QPushButton( "OK", this );
 ok->setGeometry( 30, 255, 60, 25 );
 connect( ok, SIGNAL(clicked()), SLOT(do_ok()) );
 cancel = new QPushButton( "Cancel", this );
 cancel->setGeometry( 110, 255, 60, 25 );
 connect( cancel, SIGNAL(clicked()), SLOT(reject()) );

 mono = new QRadioButton ( this, "Button 1" );
 mono->setText("Mono");
 mono->setGeometry( 40, 20, 120, 25 );
 stereo = new QRadioButton ( this, "Button 2" );
 stereo->setText("Stereo");
 stereo->setGeometry( 40, 45, 120, 25 );
 bgroup_chann = new QButtonGroup();
 bgroup_chann->insert( mono );
 bgroup_chann->insert( stereo );
 bits8 = new QRadioButton ( this, "Button 3" );
 bits8->setText("8 Bit");
 bits8->setGeometry( 40, 90, 150, 25 );
 bits16 = new QRadioButton ( this, "Button 4" );
 bits16->setText("16 Bit");
 bits16->setGeometry( 40, 115, 150, 25 );
 bgroup_bits = new QButtonGroup();
 bgroup_bits->insert( bits8 );
 bgroup_bits->insert( bits16 );
 f11 = new QRadioButton ( this, "Button 5" );
 f11->setText("11025 Hz");
 f11->setGeometry( 40, 160, 180, 25 );
 f22 = new QRadioButton ( this, "Button 6" );
 f22->setText("22050 Hz");
 f22->setGeometry( 40, 185, 180, 25 );
 f44 = new QRadioButton ( this, "Button 7" );
 f44->setText("44100 Hz");
 f44->setGeometry( 40, 210, 180, 25 );
 bgroup_freq = new QButtonGroup();
 bgroup_freq->insert( f11 );
 bgroup_freq->insert( f22 );
 bgroup_freq->insert( f44 );
 if ( w.getChannels()==1) mono->setChecked( TRUE );
 else stereo->setChecked( TRUE );
 if ( w.getBit()==8 ) bits8->setChecked( TRUE );
 else bits16->setChecked( TRUE );
 if ( w.getSampling()==11025 ) f11->setChecked( TRUE );
 else
 if ( w.getSampling()==22050 ) f22->setChecked( TRUE );
 else f44->setChecked( TRUE );
}

ChangeHz::ChangeHz( QWidget *parent, const char *name )
        : QDialog( parent, name, TRUE )
{

 setMinimumSize( 200, 170 );
 setMaximumSize( 200, 170 );
 QPushButton *ok, *cancel;
 ok = new QPushButton( "OK", this );
 ok->setGeometry( 30, 125, 60, 25 );
 connect( ok, SIGNAL(clicked()), SLOT(do_ok()) );
 cancel = new QPushButton( "Cancel", this );
 cancel->setGeometry( 110, 125, 60, 25 );
 connect( cancel, SIGNAL(clicked()), SLOT(reject()) );

 f11 = new QRadioButton ( this, "Button 5" );
 f11->setText("11025 Hz");
 f11->setGeometry( 40, 30, 180, 25 );
 f22 = new QRadioButton ( this, "Button 6" );
 f22->setText("22050 Hz");
 f22->setGeometry( 40, 55, 180, 25 );
 f44 = new QRadioButton ( this, "Button 7" );
 f44->setText("44100 Hz");
 f44->setGeometry( 40, 80, 180, 25 );
 bgroup_freq = new QButtonGroup();
 bgroup_freq->insert( f11 );
 bgroup_freq->insert( f22 );
 bgroup_freq->insert( f44 );
 if ( w.getSampling()==11025 ) f11->setChecked( TRUE );
 else
 if ( w.getSampling()==22050 ) f22->setChecked( TRUE );
 else f44->setChecked( TRUE );
}

Hall::Hall( QWidget *parent, const char *name )
        : QDialog( parent, name, TRUE )
{
 setMinimumSize( 160, 140 );
 setMaximumSize( 160, 140 );
 QPushButton *ok, *cancel;
 ok = new QPushButton( "OK", this );
 ok->setGeometry( 20, 100, 50, 25 );
 connect( ok, SIGNAL(clicked()), SLOT(do_ok()) );
 cancel = new QPushButton( "Cancel", this );
 cancel->setGeometry( 90, 100, 50, 25 );
 connect( cancel, SIGNAL(clicked()), SLOT(reject()) );

 ldel = new QLabel( "Delay:", this );
 ldel->setGeometry( 20, 15, 50, 25 );
 del = new KNumericSpinBox( this );
 del->setGeometry( 70, 15, 50, 25 );
 del->setEditable( true );
 del->setRange( 1, 5000 );
 del->setStep( 1 );
 del->setValue( 150 );
 ldel2 = new QLabel( "ms", this );
 ldel2->setGeometry( 125, 15, 20, 25 );
 lperc = new QLabel( "Percent:", this );
 lperc->setGeometry( 20, 55, 50, 25 );
 perc = new KNumericSpinBox( this );
 perc->setGeometry( 70, 55, 50, 25 );
 perc->setEditable( true );
 perc->setRange( 1, 99 );
 perc->setStep( 1 );
 perc->setValue( 60 );

 lperc2 = new QLabel( "%", this );
 lperc2->setGeometry( 125, 55, 20, 25 );

}

Color::Color( QWidget *parent, const char *name )
        : QDialog( parent, name, TRUE )
{
 setMinimumSize( 250, 250 );
 setMaximumSize( 250, 250 );
 QPushButton *ok, *cancel;
 ok = new QPushButton( "OK", this );
 ok->setGeometry( 30, 210, 50, 25 );
 connect( ok, SIGNAL(clicked()), SLOT(do_ok()) );
 cancel = new QPushButton( "Cancel", this );
 cancel->setGeometry( 170, 210, 50, 25 );
 connect( cancel, SIGNAL(clicked()), SLOT(reject()) );

 lc = new QLabel( "Left channel :", this );
 lc->setGeometry( 15, 15, 80, 25 );
 rc = new QLabel( "Right channel:", this );
 rc->setGeometry( 15, 50, 80, 25 );
 bc = new QLabel( "Background :", this );
 bc->setGeometry( 15, 85, 80, 25 );
 sc = new QLabel( "Selected area :", this );
 sc->setGeometry( 15, 120, 80, 25 );
 bsc = new QLabel( "Sel. backgr.:", this );
 bsc->setGeometry( 15, 155, 80, 25 );

 paint = new QPainter ( this );
// paint->begin( this );
 paint->fillRect( 100, 15, 40, 25, m->leftColor);
 paint->fillRect( 100, 50, 40, 25, m->rightColor);
 paint->fillRect( 100, 85, 40, 25, m->backgrColor);
 paint->fillRect( 100, 120, 40, 25, m->selColor);
 paint->fillRect( 100, 155, 40, 25, m->backSelColor);
 paint->end();
 leftC = new QColor ( m->leftColor );
 rightC= new QColor ( m->rightColor );
 backC = new QColor ( m->backgrColor );
 selC= new QColor ( m->selColor );
 backselC = new QColor ( m->backSelColor );
 left = new QPushButton( "Change", this );
 left->setGeometry( 155, 15, 70, 25 );
 connect( left, SIGNAL(clicked()), SLOT(chlcol()) );
 right = new QPushButton( "Change", this );
 right->setGeometry( 155, 50, 70, 25 );
 connect( right, SIGNAL(clicked()), SLOT(chrcol()) );
 back = new QPushButton( "Change", this );
 back->setGeometry( 155, 85, 70, 25 );
 connect( back, SIGNAL(clicked()), SLOT(chbackcol()) );
 sel = new QPushButton( "Change", this );
 sel->setGeometry( 155, 120, 70, 25 );
 connect( sel, SIGNAL(clicked()), SLOT(chselcol()) );
 backsel = new QPushButton( "Change", this );
 backsel->setGeometry( 155, 155, 70, 25 );
 connect( backsel, SIGNAL(clicked()), SLOT(chbackselcol()) );
}

Loud::Loud( QWidget *parent, const char *name )
        : QDialog( parent, name, TRUE )
{
 setMinimumSize( 160, 100 );
 setMaximumSize( 160, 100 );
 QPushButton *ok, *cancel;
 ok = new QPushButton( "OK", this );
 ok->setGeometry( 20, 60, 50, 25 );
 connect( ok, SIGNAL(clicked()), SLOT(do_ok()) );
 cancel = new QPushButton( "Cancel", this );
 cancel->setGeometry( 90, 60, 50, 25 );
 connect( cancel, SIGNAL(clicked()), SLOT(reject()) );

 ll = new QLabel( "Amplify", this );
 ll->setGeometry( 20, 15, 50, 25 );
 sb = new KNumericSpinBox( this );
 sb->setGeometry( 70, 15, 50, 25 );
 sb->setEditable( true );
 sb->setRange( 0, 500 );
 sb->setStep( 1 );
 sb->setValue( 100 );
 ll2 = new QLabel( "%", this );
 ll2->setGeometry( 125, 15, 20, 25 );
}

