/*--------------------------------------------------------------*
 |								|
 |	Waver  GUI-Methodes (C)GGENS (GPU) start 24.12.97	|
 |								|
 *--------------------------------------------------------------*/

#include <qmsgbox.h>
#include <qfiledlg.h>
#include <qstrlist.h>
#include <kcolordlg.h>
#include <kconfig.h>
#include <string.h>
#include <iostream.h>

void Wgui::menuCallback( int what )
{
 switch (what)
 {
  case ID_FILE_OPEN	: open();break;
  case ID_FILE_RELOAD	: open( w.getFileName() );break;
  case ID_FILE_QUIT	: quitwaver();break;
  case ID_FILE_SAVE	: save();break;
  case ID_FILE_SAVEAS	: saveAs();break;
  case ID_FILE_REOP1	: open( &lastWaves1[0] );break;
  case ID_FILE_REOP2	: open( &lastWaves2[0] );break;
  case ID_FILE_REOP3	: open( &lastWaves3[0] );break;
  case ID_FILE_REOP4	: open( &lastWaves4[0] );break;
  case ID_EDIT_COPY	: copy();break;
  case ID_EDIT_PASTE	: paste();break;
  case ID_EDIT_CUT	: cut();break;
  case ID_EDIT_PASTEMIX	: pastemix();break;
  case ID_EDIT_INSERT	: insertFile();break;
  case ID_EDIT_INSERTM	: insertFileMix();break;
  case ID_PLAY_PLAY	: playWav();break;
  case ID_PLAY_PAUSE	: w.pausePlay();break;
  case ID_PLAY_STOP	: w.stopPlay();break;
  case ID_PLAY_REC	: info("not implemented yet --- please hold the line");break;
  case ID_PLAY_MIXER	: system("kmix&");break;
  case ID_PLAY_RECOPT	: info("not implemented yet");break;
  case ID_TOOLS_FORMATK	: FormatDlg();break;
  case ID_TOOLS_CHNGFRQ	: ChangeHrz();break;
  case ID_TOOLS_INVERT	: invert();break;
  case ID_EFFECTS_HALL	: halldlg();break;
  case ID_EFFECTS_LOUDNESS: louddlg();break;
  case ID_EFFECTS_REVERSE: reverse(); break;
  case ID_EFFECTS_FADEIN: fadein();break;
  case ID_EFFECTS_FADEOUT: fadeout();break;
  case ID_EFFECTS_TURNRL: turnRL();break;
  case ID_EFFECTS_TURNLR: turnLR();break;
  case ID_OPTIONS_COLOR	: colordlg();break;
  case ID_OPTIONS_SAVE	: optSave();break;
  case ID_HELP_HELP: 
	KApplication::getKApplication()->invokeHTMLHelp("kwav/kwav.html","");break;
  case ID_HELP_ABOUT	: about();break;
 }
}

void Wgui::warn(char *ch)
{
 QMessageBox::warning( this, "Waver", ch );
}

void Wgui::info(char *ch)
{
 QMessageBox::information( this, "Waver", ch );
}

void Wgui::critical(char *ch)
{
 QMessageBox::critical( this, "Waver", ch );
}

void Wgui::about()
{
  QMessageBox::about( this, "Waver",
			"Waver ver. 0.0.4\n"
                        "This is a short hack of an WAV-Editor\n"
                        "It's an alpha version\n"
			"Author: Guenter Schwann\n"
			"E-mail: vogel@liberty.dyn.ml.org\n" );
} 

void Wgui::updateLW()
{

 lastLoadWaves->clear();

 lastLoadWaves->insertItem( lastWaves1, ID_FILE_REOP1 );
 lastLoadWaves->insertItem( lastWaves2, ID_FILE_REOP2 );
 lastLoadWaves->insertItem( lastWaves3, ID_FILE_REOP3 );
 lastLoadWaves->insertItem( lastWaves4, ID_FILE_REOP4 );
}

void Wgui::open()
{
 char ch[100];

 filedialog = new QFileDialog( directory, "*.wav", this, "Open file", TRUE );
 filedialog->setCaption("Open file");
 if( filedialog->exec() == 1)
 {
  setCursor( waitCursor );
  if ( w.openWave(filedialog->selectedFile().data())==0 )
  {
   directory = filedialog->dirPath();
   sprintf(ch,"Kwav %s",w.getFileName() );
   setCaption( ch );
   setStatMonSter( w.getChannels() );
   setStatSample( w.getSampling() );
   setStatBit( w.getBit() );
   setStatSize( w.getSize() );
   setStatTime();
   initPaintWave();
   startMark=0;
   endMark=0;
   paintWave();
   lastWaves4=lastWaves3;
   lastWaves3=lastWaves2;
   lastWaves2=lastWaves1;
   lastWaves1=w.getFileName();
   lastWavesSave();
   updateLW();
   if (w.getChannels()==2)
   {
    effects->setItemEnabled( ID_EFFECTS_TURNLR, TRUE );
    effects->setItemEnabled( ID_EFFECTS_TURNRL, TRUE );
   }
   else
   {
    effects->setItemEnabled( ID_EFFECTS_TURNLR, FALSE );
    effects->setItemEnabled( ID_EFFECTS_TURNRL, FALSE );
   }
  }
  setCursor( arrowCursor );
 }
}

void Wgui::open( char *fileN )
{
 char ch[100];

 if ( fileN[0]!='\0')
 {
  setCursor( waitCursor );
  if (w.openWave( fileN )==0)
  {
   sprintf(ch,"Kwav %s",w.getFileName() );
   setCaption( ch );
   setStatMonSter( w.getChannels() );
   setStatSample( w.getSampling() );
   setStatBit( w.getBit() );
   setStatSize( w.getSize() );
   setStatTime();
   initPaintWave();
   startMark=0;
   endMark=0;
   paintWave();
   if (w.getChannels()==2)
   {
    effects->setItemEnabled( ID_EFFECTS_TURNLR, TRUE );
    effects->setItemEnabled( ID_EFFECTS_TURNRL, TRUE );
   }
   else
   {
    effects->setItemEnabled( ID_EFFECTS_TURNLR, FALSE );
    effects->setItemEnabled( ID_EFFECTS_TURNRL, FALSE );
   }
  }
  setCursor( arrowCursor );
 }
}

void Wgui::save()
{
 if ( w.getWloadStat()!=0 )
 {
  if( strcmp(w.getFileName(),"")==0 ) saveAs();
  else
  {
   setCursor( waitCursor );
   w.saveWave( w.getFileName(), 0, w.getNumSamples() );
   setCursor( arrowCursor );
  }
 }
}

void Wgui::saveAs()
{
 char ch[100];
 if ( w.getWloadStat()!=0 )
 {
  filedialog = new QFileDialog( directory, "*.wav", this, "Save file", TRUE );
  filedialog->setCaption("Save file");
  if( filedialog->exec() == 1)
  {
   setCursor( waitCursor );
   w.saveWave( filedialog->selectedFile().data(), 0, w.getNumSamples() );
   w.setFileName( filedialog->selectedFile().data() );
   setCursor( arrowCursor );
  }
 }
 sprintf(ch,"Kwav %s",w.getFileName() );
 setCaption( ch ); 
}

void Wgui::paintlMark( int x, int y )
{
 paint->setPen( darkRed );
 paint->drawLine( x, y-4, x, y+4 );
 paint->drawLine( x-5, y, x, y );
 paint->drawLine( x-3, y-2, x, y );
 paint->drawLine( x-3, y+2, x, y );
}

void Wgui::paintrMark( int x, int y )
{
 paint->setPen( darkGreen );
 paint->drawLine( x, y-4, x, y+4 );
 paint->drawLine( x, y, x+5, y );
 paint->drawLine( x, y, x+3, y+2 );
 paint->drawLine( x, y, x+3, y-2 );
}

void Wgui::paint1Wave(int x, int y, int dx, int dy, int Chann)
{
  int maxheight, length, i, stm, endm;
  short *waveDatah, *waveDatal;
  QColor color;

  if (startMark>endMark)
  { 
   stm=(endMark*dx)/w.getNumSamples();
   endm=(startMark*dx)/w.getNumSamples();
  }
  else
  {
   stm=(startMark*dx)/w.getNumSamples();
   endm=(endMark*dx)/w.getNumSamples();
  }
  if (w.getWloadStat()==1)
  {
   if (Chann==1)
   {
    color=leftColor;
    waveDatah=wData1h;
    waveDatal=wData1l;
   }
   else
   {
    color=rightColor;
    waveDatah=wData2h;
    waveDatal=wData2l;
   }
   maxheight=32768;
   length=w.getNumSamples()/(dx+1);
   for(i=0;i<stm;i++)
   {
    paint->setPen( backgrColor );
    paint->drawLine(x+i, y, x+i, y+(dy/2)-(waveDatah[i]*dy)/(2*maxheight) );
    paint->drawLine(x+i, y+(dy/2)-(waveDatal[i]*dy)/(2*maxheight), x+i, y+dy );
    paint->setPen( color );
    paint->drawLine(x+i, y+(dy/2)-(waveDatal[i]*dy)/(2*maxheight),
			 x+i, y+(dy/2)-(waveDatah[i]*dy)/(2*maxheight));
    paint->setPen( black );
    paint->drawPoint( x+i, y+dy/2 );
   }
   for(i=stm;i<endm;i++)
   {
    paint->setPen( backSelColor );
    paint->drawLine(x+i, y, x+i, y+(dy/2)-(waveDatah[i]*dy)/(2*maxheight) );
    paint->drawLine(x+i, y+(dy/2)-(waveDatal[i]*dy)/(2*maxheight), x+i, y+dy );
    paint->setPen( selColor );
    paint->drawLine(x+i, y+(dy/2)-(waveDatal[i]*dy)/(2*maxheight),
			 x+i, y+(dy/2)-(waveDatah[i]*dy)/(2*maxheight));
    paint->setPen( black );
    paint->drawPoint( x+i, y+dy/2 );
   }
   for(i=endm;i<dx;i++)
   {
    paint->setPen( backgrColor );
    paint->drawLine(x+i, y, x+i, y+(dy/2)-(waveDatah[i]*dy)/(2*maxheight) );
    paint->drawLine(x+i, y+(dy/2)-(waveDatal[i]*dy)/(2*maxheight), x+i, y+dy );
    paint->setPen( color );
    paint->drawLine(x+i, y+(dy/2)-(waveDatal[i]*dy)/(2*maxheight),
			 x+i, y+(dy/2)-(waveDatah[i]*dy)/(2*maxheight));
    paint->setPen( black );
    paint->drawPoint( x+i, y+dy/2 );
   }
  }   
  paint->setPen( white );
  paint->drawLine( x, y+dy+1, x+dx+1, y+dy+1 );
  paint->drawLine( x+dx+1, y+dy+1, x+dx+1, y );
  paint->setPen( black );
  paint->drawLine( x-1, y-1, x-1, y+dy+1 );
  paint->drawLine( x, y-1, x+dx+1, y-1 );
  paint->fillRect( x-10, y+dy+2, dx+20, 7, lightGray );
}


void Wgui::paintWave()
{
  int x, y, dx, dy;
  int y_up, y_down, x_left, x_right;

 if (w.getWloadStat()!=0)
 { 
  y_up=10;
  y_down=30;
  x_left=10;
  x_right=10;
  if (menu->menuBarPos()==KMenuBar::Top) y_up+=30;
  else
   if (menu->menuBarPos()==KMenuBar::Bottom) y_down+=30;

  if (toolbar->barPos()==KToolBar::Top) y_up+=25;
  else 
   if (toolbar->barPos()==KToolBar::Bottom) y_down+=25;
   else 
    if (toolbar->barPos()==KToolBar::Left) x_left+=30;
    else 
     if (toolbar->barPos()==KToolBar::Right) x_right+=30;

 paint->fillRect( 1, 1, width(), y_up-2, lightGray );
 paint->fillRect( 1, 1, x_left-2, height(), lightGray );
 paint->fillRect( 1, height()-y_down+2, width(), y_down-2, lightGray );
 paint->fillRect( width()-x_right+2, 1, x_right-2, height(), lightGray );

  if (w.getChannels()==1)
  {
   x=x_left;
   y=y_up;
   dx=width()-x_right-x;
   dy=height()-y_down-y;
   paint1Wave( x, y, dx, dy, 1 );
   paintlMark( x+(startMark*dx)/w.getNumSamples(), y+dy+5 );
   paintrMark( x+(endMark*dx)/w.getNumSamples(), y+dy+5 );
  }
  else
  {
   x=x_left;
   y=y_up;
   dx=width()-x_right-x;
   dy=(height()-y_down-y)/2-5;
   paint1Wave( x, y, dx, dy, 1 );
   y=y+dy+10;
   paintlMark( x+(startMark*dx)/w.getNumSamples(), y-5 );
   paintrMark( x+(endMark*dx)/w.getNumSamples(), y-5 );
   paint1Wave( x, y, dx, dy, 2 );
  }
 }
}

void Wgui::pWavefree()
{
 if (pWavef>0)
 {
  free(wData1h);
  free(wData1l);
  if (pWavef==2)
  {
   free(wData2h);
   free(wData2l);
  }
 }
 pWavef=0;
}

void Wgui::initPaintWave()
{
 int i, i2, length;
 short low, high;

 pWavefree();
 wData1h = (short*) calloc( width()-20, 2 );
 wData1l = (short*) calloc( width()-20, 2 );
 length = w.getNumSamples()/(width()-19);
 for (i2=0;i2<width()-20;i2++)
 {
  low=w.leftWave(i2*length);
  high=low;
  for(i=0;i<length;i++)
  {
   if (w.leftWave(i2*length+i)>high) high=w.leftWave(i2*length+i);
   if (w.leftWave(i2*length+i)<low) low=w.leftWave(i2*length+i);
  }
  wData1h[i2]=high;
  wData1l[i2]=low;
 }
 pWavef=1;
 if (w.getChannels()==2)
 {
  wData2h = (short*) calloc( width()-20, 2 );
  wData2l = (short*) calloc( width()-20, 2 );
  for (i2=0;i2<width()-20;i2++)
  {
   low=w.rightWave(i2*length);
   high=low;
   for(i=0;i<length;i++)
   {
    if (w.rightWave(i2*length+i)>high) high=w.rightWave(i2*length+i);
    if (w.rightWave(i2*length+i)<low) low=w.rightWave(i2*length+i);
   }
   wData2h[i2]=high;
   wData2l[i2]=low;
  }
  pWavef=2;
 }
}

void Wgui::paintEvent( QPaintEvent *r )
{
 KTopLevelWidget::paintEvent( r );
 if (w.getWloadStat()!=0) paintWave();
}

void Wgui::resizeEvent( QResizeEvent *r )
{
 KTopLevelWidget::resizeEvent( r );
 if (w.getWloadStat()!=0) initPaintWave();
 if (w.getWloadStat()!=0) paintWave();
}

void Wgui::mousePressEvent( QMouseEvent *me )
{
 startMark=(w.getNumSamples()*(me->x()-10))/(width()-20);
 if ((me->x())>(width()-10)) startMark=w.getNumSamples();
 if ((me->x())<10) startMark=0;
 endMark=startMark;
}

void Wgui::mouseReleaseEvent( QMouseEvent *me )
{
 endMark=(w.getNumSamples()*(me->x()-10))/(width()-20);
 if ((me->x())>(width()-10)) endMark=w.getNumSamples();
 if ((me->x())<10) endMark=0;
 paintWave();
}

void Wgui::mouseMoveEvent( QMouseEvent *me )
{
 endMark=(w.getNumSamples()*(me->x()-10))/(width()-20);
 if ((me->x())>(width()-10)) endMark=w.getNumSamples();
 if ((me->x())<10) endMark=0;
 paintWave();
}

void Wgui::initPlayMenu()
{
 if (w.getActivePlay()==0)
 {
  wplay->setItemEnabled( ID_PLAY_PLAY, TRUE );
  wplay->setItemEnabled( ID_PLAY_STOP, FALSE );
  wplay->setItemEnabled( ID_PLAY_PAUSE, FALSE );
 }
 else
 {
  wplay->setItemEnabled( ID_PLAY_PLAY, FALSE );
  wplay->setItemEnabled( ID_PLAY_STOP, TRUE );
  wplay->setItemEnabled( ID_PLAY_PAUSE, TRUE );
 }
}

void Wgui::playWav()
{
 int speed;

 if ( (w.getWloadStat()==1)&&(w.getActivePlay()==0) )
 {
  speed=(256*5000)/(w.getSampling()*w.getChannels());
  if (w.getCurrPlayPos()!=0)
  {
   timer = new QTimer( m );
   connect( timer, SIGNAL(timeout()), this, SLOT(timerEv()) );
   timer->start( speed, FALSE );
  }
  else
  {
   if (w.initPlay()>-1)
   {
    timer = new QTimer( m );
    connect( timer, SIGNAL(timeout()), this, SLOT(timerEv()) );
    timer->start( speed, FALSE );
   }
   else warn("Problems with audio-device");
  }
 }
 initPlayMenu();
}

void Wgui::timerEv()
{
 w.play();
}

void Wgui::setStatMonSter( int i )
{
 char str[10];
 
 if (i==1) sprintf(str," Mono ");
  else sprintf(str," Stereo ");
 stat->changeItem( str, ID_STAT_MONSTER );
}

void Wgui::setStatSample( int i )
{
 char str[15];
 
 sprintf(str," %d kHz ",i);
 stat->changeItem( str, ID_STAT_SAMPLE );
}

void Wgui::setStatBit( int i )
{
 char str[10];
 
 sprintf(str," %d Bit ",i);
 stat->changeItem( str, ID_STAT_BIT );
}

void Wgui::setStatSize( int i )
{
 char str[12];
 
 i=i / 1024;
 sprintf(str," %d kB ",i);
 stat->changeItem( str, ID_STAT_SIZE );
}

void Wgui::setStatTime()
{
 char str[15];
 float f,f1;
 
 f=w.getNumSamples();
 f1=w.getSampling();
 f=f/f1;
 sprintf(str," %4.1f sec ",f);
 stat->changeItem( str, ID_STAT_TIME );
}

void Wgui::invert()
{
 w.invert();
}

void Wgui::optSave()
{
 KConfig *config=kapp->getConfig();
 QString oldgroup = config->group();

 config->setGroup( "Colors" );
 config->writeEntry( "left channel", leftColor );
 config->writeEntry( "right channel", rightColor );
 config->writeEntry( "background", backgrColor );
 config->writeEntry( "selected", selColor );
 config->writeEntry( "selected background", backSelColor );
 
 config->setGroup( oldgroup );
}

void Wgui::lastWavesSave()
{
 KConfig *config=kapp->getConfig();
 QString oldgroup = config->group();

 config->setGroup( "Waves" );
 config->writeEntry( "wave1", lastWaves1 );
 config->writeEntry( "wave2", lastWaves2 );
 config->writeEntry( "wave3", lastWaves3 );
 config->writeEntry( "wave4", lastWaves4 );
 config->setGroup( oldgroup );
}

void Wgui::optLoad()
{
 KConfig *config = kapp->getConfig();
 QString oldgroup = config->group();
 QColor defleft = red;
 QColor defright = blue;
 QColor backgr = gray;
 QColor sel = black;
 QColor selback = yellow;

 config->setGroup( "Colors" );
 leftColor = config->readColorEntry( "left channel", &defleft );
 rightColor = config->readColorEntry( "right channel", &defright );
 backgrColor = config->readColorEntry( "background", &backgr );
 selColor = config->readColorEntry( "selected", &sel );
 backSelColor = config->readColorEntry( "selected background", &selback );

 config->setGroup( "Waves" );
 lastWaves1 = config->readEntry( "wave1", "" );
 lastWaves2 = config->readEntry( "wave2", "" );
 lastWaves3 = config->readEntry( "wave3", "" );
 lastWaves4 = config->readEntry( "wave4", "" );
 config->setGroup( oldgroup );
}

void Wgui::FormatDlg()
{
 if ( w.getWloadStat()!=0 )
 {
  konvFormat *f;
  f = new konvFormat (this, "Konvert Format");
  f->setCaption( "Konvert Format" );
  f->exec();
 }
}

void konvFormat::do_ok()
{
 setCursor( waitCursor );
 m->setCursor( waitCursor );
 if ( mono->isChecked()==TRUE ) w.toMono();
 else w.toStereo();
 if ( bits8->isChecked()==TRUE ) w.Bitsto8();
 else w.Bitsto16();
 if ( f11->isChecked()==TRUE) w.Hzto(11025);
 if ( f22->isChecked()==TRUE) w.Hzto(22050);
 if ( f44->isChecked()==TRUE) w.Hzto(44100);
 accept();
 m->setStatMonSter( w.getChannels() );
 m->setStatBit( w.getBit() );
 m->setStatSample( w.getSampling() );
 m->setStatSize( w.getSize() );
 setCursor( arrowCursor );
 m->initPaintWave();
 m->paintWave();
 if (w.getChannels()==2)
 {
  m->effects->setItemEnabled( ID_EFFECTS_TURNLR, TRUE );
  m->effects->setItemEnabled( ID_EFFECTS_TURNRL, TRUE );
 }
 else
 {
  m->effects->setItemEnabled( ID_EFFECTS_TURNLR, FALSE );
  m->effects->setItemEnabled( ID_EFFECTS_TURNRL, FALSE );
 }
 m->setCursor( arrowCursor );
}

void Wgui::ChangeHrz()
{
 if ( w.getWloadStat()!=0 )
 {
  ChangeHz *f;
  f = new ChangeHz (this, "Change Sampling-rate");
  f->setCaption( "Change Sampling-rate" );
  f->exec();
 }
}

void ChangeHz::do_ok()
{
 setCursor( waitCursor );
 m->setCursor( waitCursor );
 if ( f11->isChecked()==TRUE) w.ChangeFrq( 11025 );
 if ( f22->isChecked()==TRUE) w.ChangeFrq( 22050 );
 if ( f44->isChecked()==TRUE) w.ChangeFrq( 44100 );
 accept();
 m->setStatMonSter( w.getChannels() );
 m->setStatBit( w.getBit() );
 m->setStatSample( w.getSampling() );
 m->setStatSize( w.getSize() );
 m->setStatTime();
 setCursor( arrowCursor );
 m->setCursor( arrowCursor );
}

void Wgui::halldlg()
{
 if ( w.getWloadStat()!=0 )
 {
  Hall *h;
  h = new Hall (this, "Add hall");
  h->setCaption( "add hall" );
  h->exec();
 }
}

void Hall::do_ok()
{
 int i;
 accept();
 setCursor( waitCursor );
 m->setCursor( waitCursor );
 i = del->getValue();
 if (i>99) i=99;
 w.hall( i*w.getSampling()/1000, perc->getValue() );
 m->setStatSize( w.getSize() );
 m->setStatTime();
 setCursor( arrowCursor );
 m->setCursor( arrowCursor );
}

void Wgui::colordlg()
{
  Color *c;
  c = new Color (this, "Change color");
  c->setCaption( "Change color" );
  c->exec();
}

void Color::do_ok()
{
 m->leftColor = *leftC;
 m->rightColor = *rightC;
 m->backgrColor = *backC;
 m->selColor = *selC;
 m->backSelColor = *backselC;
 accept();
}

void Color::chlcol()
{
 KColorDialog::getColor( *leftC );
}

void Color::chrcol()
{
 KColorDialog::getColor( *rightC );
}

void Color::chbackcol()
{
 KColorDialog::getColor( *backC );
}

void Color::chselcol()
{
 KColorDialog::getColor( *selC );
}

void Color::chbackselcol()
{
 KColorDialog::getColor( *backselC );
}

void Color::paintEvent( QPaintEvent *r )
{
 QDialog::paintEvent( r );
 paint->begin( this );
 paint->fillRect( 100, 15, 40, 25, *leftC);
 paint->fillRect( 100, 50, 40, 25, *rightC); 
 paint->fillRect( 100, 85, 40, 25, *backC);
 paint->fillRect( 100, 120, 40, 25, *selC); 
 paint->fillRect( 100, 155, 40, 25, *backselC);
 paint->end();
}

void Wgui::reverse()
{
 if ( w.getWloadStat()!=0 )
 {
  m->setCursor( waitCursor );
  w.reverse(w.waveData1);
  if (w.getChannels()==2) w.reverse(w.waveData2);
  m->setCursor( arrowCursor );
 }
}

void Wgui::louddlg()
{
 if ( w.getWloadStat()!=0 )
 {
  Loud *l;
  l = new Loud (this, "Change loudness");
  l->setCaption( "Change loudness" );
  l->exec();
 }
}

void Loud::do_ok()
{
 setCursor( waitCursor );
 m->setCursor( waitCursor );
 w.loudness( sb->getValue() );
 setCursor( arrowCursor );
 m->setCursor( arrowCursor );
 accept();
}

void Wgui::cut()
{
 if (w.getWloadStat()!=0)
 {
  w.cut( startMark, endMark );
  if (startMark>w.getNumSamples()) startMark=w.getNumSamples();
  endMark=startMark;
  initPaintWave();
  paintWave();
  m->setStatSize( w.getSize() );
  m->setStatTime();
 }
}

void Wgui::copy()
{
 if (w.getWloadStat()!=0)
 {
  w.copy( startMark, endMark );
 }
}

void Wgui::pastemix()
{
 if (w.getWloadStat()!=0)
 {
  w.insertWavemix("/tmp/kwav-clipboard.wav", startMark);
  initPaintWave();
  paintWave();
 }
}

void Wgui::paste()
{
 if (w.getWloadStat()!=0)
 {
  w.insertWave("/tmp/kwav-clipboard.wav", startMark);
  initPaintWave();
  paintWave();
  setStatSize( w.getSize() );
  setStatTime();
 }
}

void Wgui::insertFileMix()
{
 if (w.getWloadStat()!=0)
 {
  filedialog = new QFileDialog( directory, "*.wav", this, "Open file", TRUE );
  filedialog->setCaption("Insert file");
  if( filedialog->exec() == 1)
  {
   setCursor( waitCursor );
   w.insertWavemix( filedialog->selectedFile().data(), startMark );
   initPaintWave();
   paintWave();
   setCursor( arrowCursor );
  }
 }
}

void Wgui::insertFile()
{
 if (w.getWloadStat()!=0)
 {
  filedialog = new QFileDialog( directory, "*.wav", this, "Open file", TRUE );
  filedialog->setCaption("Insert file");
  if( filedialog->exec() == 1)
  {
   setCursor( waitCursor );
   w.insertWave( filedialog->selectedFile().data(), startMark );
   initPaintWave();
   paintWave();
   setStatSize( w.getSize() );
   setStatTime();
   setCursor( arrowCursor );
  }
 }
}

void Wgui::fadein()
{
 if (w.getWloadStat()!=0)
 {
  w.fadeIn( startMark, endMark, 100, 1 );
  if ( w.getChannels()==2 )
   w.fadeIn( startMark, endMark, 100, 2 );
  initPaintWave();
  paintWave();
 }
}

void Wgui::fadeout()
{
 if (w.getWloadStat()!=0)
 {
  w.fadeOut( startMark, endMark, 100, 1 );
  if ( w.getChannels()==2 )
   w.fadeOut( startMark, endMark, 100, 2 );
  initPaintWave();
  paintWave();
 }
}

void Wgui::dropEvent(KDNDDropZone *dz)
{
 QStrList & list = dz->getURLList();
 char *s;
 char ch[100];

 s=list.first();
 QString n = s;
 if (n.left(5)=="file:")
 {
  setCursor( waitCursor );
  if (w.openWave( &n[5] )==0)
  {
   sprintf(ch,"Kwav %s",w.getFileName() );
   setCaption( ch );
   setStatMonSter( w.getChannels() );
   setStatSample( w.getSampling() );
   setStatBit( w.getBit() );
   setStatSize( w.getSize() );
   setStatTime();
   initPaintWave();
   startMark=0;
   endMark=0;
   paintWave();
   lastWaves4=lastWaves3;
   lastWaves3=lastWaves2;
   lastWaves2=lastWaves1;
   lastWaves1=w.getFileName();
   lastWavesSave();
   updateLW();
  }
  setCursor( arrowCursor );
   if (w.getChannels()==2)
   {
    effects->setItemEnabled( ID_EFFECTS_TURNLR, TRUE );
    effects->setItemEnabled( ID_EFFECTS_TURNRL, TRUE );
   }
   else
   {
    effects->setItemEnabled( ID_EFFECTS_TURNLR, FALSE );
    effects->setItemEnabled( ID_EFFECTS_TURNRL, FALSE );
   }
 }
}

void Wgui::turnRL()
{
 if ((w.getWloadStat()!=0)&&(w.getChannels()==2))
 {
  w.fadeIn( 0, w.getNumSamples()/2, 100, 1 );
  w.fadeOut( w.getNumSamples()/2, w.getNumSamples(), 100, 2 );
  initPaintWave();
  paintWave();
 }
}

void Wgui::turnLR()
{
 if ((w.getWloadStat()!=0)&&(w.getChannels()==2))
 {
  w.fadeIn( 0, w.getNumSamples()/2, 100, 2 );
  w.fadeOut( w.getNumSamples()/2, w.getNumSamples(), 100, 1 );
  initPaintWave();
  paintWave();
 }
}

