/*--------------------------------------------------------------*
 |								|
 |	Waver  header-file (C)GGENS (GPU) start 24.12.97	|
 |								|
 *--------------------------------------------------------------*/

#include <ktopwidget.h>
#include <qwidget.h>
#include <qfiledlg.h>
#include <qpainter.h>
#include <qradiobt.h>
#include <qbttngrp.h>
#include <qlined.h>
#include <qlabel.h>
#include <qtimer.h>
#include <kmenubar.h>
#include <kpopmenu.h>
#include <kstatusbar.h>
#include <ktoolbar.h>
#include <kapp.h>
#include <kspinbox.h>

// constants for menu
#define ID_FILE_OPEN 11
#define ID_FILE_RELOAD 12
#define ID_FILE_SAVE 13
#define ID_FILE_SAVEAS 14
#define ID_FILE_QUIT 19
#define ID_FILE_REOP1 111
#define ID_FILE_REOP2 112
#define ID_FILE_REOP3 113
#define ID_FILE_REOP4 114
#define ID_EDIT_COPY 21
#define ID_EDIT_PASTE 22
#define ID_EDIT_CUT 23
#define ID_EDIT_PASTEMIX 24
#define ID_EDIT_INSERT 25
#define ID_EDIT_INSERTM 26
#define ID_PLAY_PLAY 31
#define ID_PLAY_PAUSE 32
#define ID_PLAY_STOP 33
#define ID_PLAY_REC 35
#define ID_PLAY_MIXER 37
#define ID_PLAY_RECOPT 38
#define ID_TOOLS_FORMATK 41
#define ID_TOOLS_CHNGFRQ 42
#define ID_TOOLS_INVERT 43
#define ID_EFFECTS_HALL 51
#define ID_EFFECTS_LOUDNESS 52
#define ID_EFFECTS_REVERSE 53
#define ID_EFFECTS_FADEIN 54
#define ID_EFFECTS_FADEOUT 55
#define ID_EFFECTS_TURNRL 56
#define ID_EFFECTS_TURNLR 57
#define ID_OPTIONS_COLOR 81
#define ID_OPTIONS_SAVE 89
#define ID_HELP_HELP 91
#define ID_HELP_ABOUT 99

// constants for statusbar
#define ID_STAT_MONSTER 1
#define ID_STAT_SAMPLE 2
#define ID_STAT_BIT 3
#define ID_STAT_SIZE 4
#define ID_STAT_TIME 5

//class for GUI
class Wgui : public KTopLevelWidget
{
 Q_OBJECT
 public:
  Wgui( const char *name=0 );
  ~Wgui();
 
  KMenuBar *menu;
  QPopupMenu *file, *lastLoadWaves, *edit, *wplay, *tools, *effects, *options,
   *help;
  KToolBar *toolbar;
  KStatusBar *stat;
  KDNDDropZone *dropZone;
  QColor leftColor, rightColor;
  QColor selColor, backSelColor;
  QColor backgrColor;
  QTimer *timer;

 public slots:
  void updateLW();
  void quitwaver();
  void menuCallback( int );
  void about();
  void warn( char * );
  void info( char * );
  void critical( char * );
  void setStatMonSter( int );
  void setStatSample( int );
  void setStatBit( int );
  void setStatSize( int );
  void setStatTime();
  void paintWave();
  void open();
  void open(char*);
  void save();
  void saveAs();
  void FormatDlg();
  void ChangeHrz();
  void playWav();
  void halldlg();
  void colordlg();
  void reverse();
  void louddlg();
  void invert(); 
  void optSave();
  void optLoad();
  void lastWavesSave();
  void initPaintWave();
  void pWavefree();
  void cut();
  void copy();
  void pastemix();
  void paste();
  void fadein();
  void fadeout();
  void insertFile();
  void insertFileMix();
  void dropEvent( KDNDDropZone * );
  void turnRL();
  void turnLR();
  void timerEv();
  void initPlayMenu();

 protected:
  void paintEvent( QPaintEvent * );
  void resizeEvent ( QResizeEvent * );
  void mousePressEvent( QMouseEvent * );
  void mouseReleaseEvent( QMouseEvent * );
  void mouseMoveEvent( QMouseEvent * );

 private:

  QFileDialog *filedialog;
  QPainter *paint;
  short *wData1h, *wData1l;
  short *wData2h, *wData2l;
  int pWavef;
  int startMark, endMark;
  QString lastWaves1;
  QString lastWaves2;
  QString lastWaves3;
  QString lastWaves4;
  QString directory;

  void paint1Wave(int, int, int, int, int );
  void paintlMark(int, int);
  void paintrMark(int, int);
};


#include <fstream.h>

//class for wave-file
class Wave
{
 public:
  Wave();
  ~Wave();
  int getSize();
  int getSampling();
  int getBit();
  int getChannels();
  int getNumSamples();
  int openWave( char * );
  void saveWave( char *, int, int );
  void freemem();
  int getWloadStat();
  void setWloadStat( int );
  void setFileName(char *);
  char *getFileName();
  void toStereo();
  void toMono();
  void Bitsto8();
  void Bitsto16();
  void Hzto( int );
  void ChangeFrq( int );
  void hall(int, int);
  void reverse(short *);
  void loudness( int );
  void invert();
  short leftWave(int);
  short rightWave(int);
  void cut(int, int);
  void copy(int, int);
  void insertWavemix(char *,int);
  void insertWave(char *,int);
  int initPlay();
  void play();
  void stopPlay();
  void pausePlay();
  void fadeIn( int, int, int, int );
  void fadeOut( int, int, int, int );
  int getActivePlay();
  int getCurrPlayPos();
  int getDSPBuffer();

  short *waveData1;
  short *waveData2;

 private:
  char FileName[80];
  int Size;
  int Sampling;
  int bit;
  int Channels;
  int loaded;
  int NumSamples;
  int currPlayPos;
  int playActive;

  int dsp_speed;
  int dsp_samplesize;
  int dsp_stereo;
  QString audio_dev;
  int audio;
  short *buffer;
  int buffer_size;

  void setSize( int );
  void setSampling( int );
  void setBit( int );
  void setChannels( int );
  void setNumSamples( int );
  int chtoint( unsigned char );
  unsigned char inttoch( int );
  void downmix1( int ); //INTERPOLATION EINBAUEN!!!
  void downmix2( int ); //INTERPOLATION EINBAUEN!!!
  void upmix1( int ); //INTERPOLATION EINBAUEN!!!
  void upmix2( int ); //INTERPOLATION EINBAUEN!!!
};


// konvert Format
class konvFormat : public QDialog 
{
 Q_OBJECT
 public:
  konvFormat( QWidget *parent, const char *name );

  QRadioButton *mono;
  QRadioButton *stereo;
  QButtonGroup *bgroup_chann;
  QRadioButton *bits8;
  QRadioButton *bits16;
  QButtonGroup *bgroup_bits;
  QRadioButton *f11;
  QRadioButton *f22;
  QRadioButton *f44;
  QButtonGroup *bgroup_freq;

 public slots:
  void do_ok();
};


// Change only Frequency 
class ChangeHz : public QDialog 
{
 Q_OBJECT
 public:
  ChangeHz( QWidget *parent, const char *name );

  QRadioButton *f11;
  QRadioButton *f22;
  QRadioButton *f44;
  QButtonGroup *bgroup_freq;

 public slots:
  void do_ok();
};

// Add hall
class Hall : public QDialog 
{
 Q_OBJECT
 public:
  Hall( QWidget *parent, const char *name );

// QLineEdit *del;
 KNumericSpinBox *del;
 QLabel *ldel;
 QLabel *ldel2;
// QLineEdit *perc;
 KNumericSpinBox *perc;
 QLabel *lperc;
 QLabel *lperc2;

 public slots:
  void do_ok();
};

// Change Color
class Color : public QDialog 
{
 Q_OBJECT
 public:
  Color( QWidget *parent, const char *name );

 QLabel *lc;
 QLabel *rc;
 QLabel *bc;
 QLabel *sc;
 QLabel *bsc;
 QPushButton *left;
 QPushButton *right;
 QPushButton *back;
 QPushButton *sel;
 QPushButton *backsel;
 QColor *leftC, *rightC;
 QColor *selC, *backselC;
 QColor *backC;

 public slots:
  void do_ok();
  void chlcol();
  void chrcol();
  void chbackcol();
  void chselcol();
  void chbackselcol();

 protected:
  void paintEvent( QPaintEvent * );

 private:
  QPainter *paint;

};

// Change loudness
class Loud : public QDialog 
{
 Q_OBJECT
 public:
  Loud( QWidget *parent, const char *name );

// QLineEdit *l;
 KNumericSpinBox *sb;
 QLabel *ll;
 QLabel *ll2;

 public slots:
  void do_ok();
};

