/*--------------------------------------------------------------*
 |								|
 |	Waver  wave-tools (C)GGENS (GPU) start 24.12.97 	|
 |								|
 *--------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/soundcard.h>

int Wave::getSize()
{
 return Size;
}

int Wave::getSampling()
{
 return Sampling;
}

int Wave::getBit()
{
 return bit;
}

int Wave::getChannels()
{
 return Channels;
}

int Wave::getNumSamples()
{
 return NumSamples;
}

int Wave::chtoint( unsigned char ch )
{
 return ((ch-127)*256);
}

unsigned char Wave::inttoch( int i )
{
return ((i/256)+127);
}

void Wave::setFileName( char *filen )
{
 strcpy(FileName,filen);
}

char *Wave::getFileName()
{
 return FileName;
}

int Wave::openWave( char *filename )
{
 int ok;
 int i, avBpS;
 short sh, bpS;
 void *ch, *ch1;
 char str[40];
 unsigned char st[10];

 ifstream ifl( filename, ios::in|ios::binary);
 if (!ifl) ok=1;
 else
 {
  ok=0;
  ifl.read( str, 4 );
  str[4]='\0';
  if ( strcmp(str,"RIFF")!=0 ) ok=2;
  else
  {
   ifl.read( &i, 4 );
   ifl.read( str, 4 );
   str[4]='\0';
   if ( strcmp(str,"WAVE")!=0 ) ok=2;
   else
   {
	setFileName( filename );
	free( waveData1 );
	if (getChannels()==2) free( waveData2 );
	i=0;
	while (i==0) 
	{
	 ifl.read( str, 1 );
	 if (str[0]=='f')
	 {
	  ifl.read( str, 1 );
	  if (str[0]=='m')
	  {
	   ifl.read( str, 1 );
	   if (str[0]=='t')
	   {
	    ifl.read( str, 1 );
	    if (str[0]==' ') i=1;
	   }
	  }
	 }
	}

	ifl.read( &i, 4 );
	ifl.read( &sh, 2 );
	ifl.read( &sh, 2 );
	i=sh;
        setChannels( i );
        ifl.read( &i, 4 );
	setSampling( i );
        ifl.read( &i, 4 );
	avBpS=i;
        ifl.read( &sh, 2 );
	bpS=sh;
        ifl.read( &sh, 2 );
	i=sh;
        setBit( i );
	ifl.read( str, 4 );
	ifl.read( &i, 4 );
	setSize( i );
	setNumSamples( getSize() / bpS );
	if (getChannels()==1)
	{
	 ch=waveData1;
	 waveData1 = (short*) calloc( getNumSamples(), 2 );
	 if (getBit()==8)
	 {
	  for (i=0;i<getNumSamples();i++)
	  {
	   ifl.read( st, 1 );
	   waveData1[i]=chtoint( st[0] );
	  }
	 }
	 else
	 {
	  for (i=0;i<getNumSamples();i++)
	  {
	   ch=&waveData1[i];
	   ifl.read( ch, 2 );
	  }
	 }
	}
	else
	{
	 if (getBit()==8)
	 {
	  waveData1 = (short*) calloc( getNumSamples(), 2 );
	  waveData2 = (short*) calloc( getNumSamples(), 2 );
	  for (i=0;i<getNumSamples();i++)
	  {
           ifl.read( st, 2 );
	   waveData1[i]=chtoint( st[0] );
	   waveData2[i]=chtoint( st[1] );
	  }
	 }
	 else
	 {
	  waveData1 = (short*) calloc( getNumSamples(), 2 );
	  waveData2 = (short*) calloc( getNumSamples(), 2 );
	  for (i=0;i<getNumSamples();i++)
	  {
	   ch=&waveData1[i];
	   ch1=&waveData2[i];
           ifl.read( ch, 2 );
           ifl.read( ch1, 2 );
	  }
	 }
	}
	loaded=1;
   }
  }
 }
 if (ok!=0)
 {
  switch ( ok )
  {
   case 1: strcpy(str,"Can't open file!"); break;
   case 2: strcpy(str,"file is no WAV-file"); break;
  }
  m->warn( str );
 }
 return ok;
}

void Wave::saveWave( char *filename, int startpos, int endpos )
{
 int i, length;
 char str[40];
 short sh;
 unsigned char ch;
 void *vo;

 ofstream ofl( filename, ios::out|ios::binary);
 if (!ofl)
 {
  strcpy( str, "Can't open file!" );
  m->warn( str );
 }
 else
 {
  length=endpos-startpos;
  strcpy( str, "RIFF" );
  ofl.write( str, 4 );
  i=length*(getBit()/8)*getChannels()+36;
  ofl.write( &i, 4 );
  strcpy( str, "WAVE" );
  ofl.write( str, 4 );
  strcpy( str, "fmt " );
  ofl.write( str, 4 );
  i=16;
  ofl.write( &i, 4 );
  sh=1;
  ofl.write( &sh, 2);
  sh=getChannels();
  ofl.write( &sh, 2);
  i=getSampling();
  ofl.write( &i, 4 );
  i=getSampling()*getChannels()*(getBit()/8);
  ofl.write( &i, 4 );
  sh=getChannels()*(getBit()/8);
  ofl.write( &sh, 2 );
  sh=getBit();
  ofl.write( &sh, 2 );
  strcpy( str, "data");
  ofl.write( str, 4 );
  i=length*getBit()/8*getChannels();
  ofl.write( &i, 4 );
  if (getChannels()==1)
  {
   if (getBit()==8)
   {
    for(i=startpos;i<endpos;i++)
    {
     ch=inttoch( waveData1[i] );
     vo=&ch;
     ofl.write( vo, 1 );
    }
   }
   else
   {
    for(i=startpos;i<endpos;i++)
    {
     vo=&waveData1[i];
     ofl.write( vo, 2 );
    }
   }
  }
  else
  {
   if (getBit()==8)
   {
    for(i=startpos;i<endpos;i++)
    {
     ch=inttoch( waveData1[i] );
     vo=&ch;
     ofl.write( vo, 1 );
     ch=inttoch( waveData2[i] );
     vo=&ch;
     ofl.write( vo, 1 );
    }
   }
   else
   {
    for(i=startpos;i<endpos;i++)
    {
     vo=&waveData1[i];
     ofl.write( vo, 2 );
     vo=&waveData2[i];
     ofl.write( vo, 2 );
    }
   }
  }
 }
}

void Wave::freemem()
{
 free( waveData1 );
 if (getChannels()==2) free( waveData2 );
}

int Wave::getWloadStat()
{
 return loaded;
}

void Wave::setSize( int i )
{
 Size=i;
}

void Wave::setSampling( int i )
{
 Sampling=i;
}

void Wave::setBit( int i )
{
 bit=i;
}

void Wave::setChannels(int i )
{
 Channels=i;
}

void Wave::setNumSamples(int i )
{
 NumSamples=i;
}

void Wave::setWloadStat( int l )
{
 loaded=l;
}

void Wave::toStereo()
{
 int i;
 
 if ( getChannels()==1)
 {
  waveData2 = (short*) calloc( getNumSamples(), 2 );
  for (i=0;i<getNumSamples();i++) waveData2[i]=waveData1[i];
  setChannels( 2 );
  setSize( getSize()*2 );
 }
}

void Wave::toMono()
{
 if ( getChannels()==2 )
 {
  free( waveData2 );
  setChannels( 1 );
  setSize( getSize()/2 );
 }
}

void Wave::Bitsto8()
{
 if ( getBit()!=8 )
 {
  setBit( 8 );
  setSize( getSize()/2 );
 }
}

void Wave::Bitsto16()
{
 if ( getBit()!=16 )
 {
  setBit( 16 );
  setSize( getSize()*2 );
 }
}

void Wave::downmix1( int newfreq )
{
 float f;
 int i, s;
 int newNumSamples;
 short *newW;

 f=getSampling()/newfreq;
 newNumSamples=int(getNumSamples()/f);
 newW = (short*) calloc( newNumSamples, 2 );
 for (i=0;i<newNumSamples;i++)
 {
  s=int(i*f);
  newW[i]=waveData1[s];
 }
 waveData1 = (short*) realloc ( waveData1, newNumSamples*2 );
 for (i=0;i<newNumSamples;i++) waveData1[i]=newW[i];
 free ( newW );
 setNumSamples( newNumSamples );
 setSampling( newfreq );
 setSize( getNumSamples()*(getBit()/8)*getChannels() );
}

void Wave::downmix2( int newfreq )
{
 float f;
 int i, s;
 int newNumSamples;
 short *newW;

 f=getSampling()/newfreq;
 newNumSamples=int(getNumSamples()/f);
 newW = (short*) calloc( newNumSamples, 2 );
 for (i=0;i<newNumSamples;i++)
 {
  s=int(i*f);
  newW[i]=waveData2[s];
 }
 waveData2 = (short*) realloc ( waveData2, newNumSamples*2 );
 for (i=0;i<newNumSamples;i++) waveData2[i]=newW[i];
 free ( newW );
}

void Wave::upmix1( int newfreq )
{
 float f;
 int i, s;
 int newNumSamples;
 short *newW;

 f=newfreq/getSampling();
 newNumSamples=int(getNumSamples()*f);
 newW = (short*) calloc( newNumSamples, 2 );
 for (i=0;i<newNumSamples;i++)
 {
  s=int(i/f);
  newW[i]=waveData1[s];
 }
 waveData1 = (short*) realloc ( waveData1, newNumSamples*2 );
 for (i=0;i<newNumSamples;i++) waveData1[i]=newW[i];
 free ( newW );
 setNumSamples( newNumSamples );
 setSampling( newfreq );
 setSize( getNumSamples()*(getBit()/8)*getChannels() );
}

void Wave::upmix2( int newfreq )
{
 float f;
 int i, s;
 int newNumSamples;
 short *newW;

 f=newfreq/getSampling();
 newNumSamples=int(getNumSamples()*f);
 newW = (short*) calloc( newNumSamples, 2 );
 for (i=0;i<newNumSamples;i++)
 {
  s=int(i/f);
  newW[i]=waveData2[s];
 }
 waveData2 = (short*) realloc ( waveData2, newNumSamples*2 );
 for (i=0;i<newNumSamples;i++) waveData2[i]=newW[i];
 free ( newW );
}

void Wave::Hzto( int freq )
{
 if ( getSampling()>freq) 
 {
  if (getChannels()==2) downmix2( freq );
  downmix1( freq );
 }
 if ( getSampling()<freq) 
 {
  if (getChannels()==2) upmix2( freq );
  upmix1( freq );
 }
}

void Wave::ChangeFrq( int Freq )
{
 setSampling( Freq );
}

short Wave::leftWave(int i)
{
 return waveData1[i];
}

short Wave::rightWave(int i)
{
 return waveData2[i];
}

void Wave::cut(int start, int end)
{
 int i, length, newSamples;

 if (start>end)
 {
  i=end;
  end=start;
  start=i;
 }
 saveWave( "/tmp/kwav-clipboard.wav", start, end );
 length=end-start;
 newSamples=getNumSamples()-length;
 for (i=start;i<newSamples;i++)
 {
  waveData1[i]=waveData1[i+length];
  if (getChannels()==2) waveData2[i]=waveData2[i+length];
 }
 waveData1 = (short*) realloc( waveData1, newSamples*2 );
 if (getChannels()==2) 
  waveData2 = (short*) realloc( waveData2, newSamples*2 );
 setNumSamples( newSamples );
 setSize( getNumSamples()*getBit()/8*getChannels() );
}

void Wave::copy( int start, int end)
{
 saveWave( "/tmp/kwav-clipboard.wav", start, end );
}

void Wave::insertWavemix( char *file, int pos )
{
 int i, length;

 addW.openWave( file );
 if (addW.getWloadStat()!=0)
 { 
  if ( Channels==1 ) addW.toMono();
  else addW.toStereo();
  if ( bit==8 ) addW.Bitsto8();
  else addW.Bitsto16();
  if ( Sampling==11025 ) addW.Hzto(11025);
  if ( Sampling==22050 ) addW.Hzto(22050);
  if ( Sampling==44100 ) addW.Hzto(44100);

  length=addW.getNumSamples(); 
  if ( addW.getNumSamples()>NumSamples-pos) length=NumSamples-pos;

  for (i=0;i<length;i++)
  {
   waveData1[i+pos]+=addW.waveData1[i];
   if (Channels==2)
    waveData2[i+pos]+=addW.waveData2[i];
  }
 }
// addW.freemem();
// addW.setWloadStat( 0 );
}

void Wave::insertWave( char *file, int pos )
{
 int i;

 addW.openWave( file );
 if (addW.getWloadStat()!=0)
 {
  if ( Channels==1 ) addW.toMono();
   else addW.toStereo();
  if ( bit==8 ) addW.Bitsto8();
   else addW.Bitsto16();
  if ( Sampling==11025 ) addW.Hzto( 11025 );
  if ( Sampling==22050 ) addW.Hzto( 22050 );
  if ( Sampling==44100 ) addW.Hzto( 44100 );

  waveData1 = ( short * ) realloc( waveData1, (NumSamples+addW.getNumSamples())*2 );
  if (Channels==2) 
   waveData2 = ( short * ) realloc( waveData2, (NumSamples+addW.getNumSamples())*2 );
  NumSamples+=addW.getNumSamples();
  for (i=NumSamples-1;i>pos+addW.getNumSamples();i--)
  {
   waveData1[i]=waveData1[i-addW.getNumSamples()];
   if (Channels==2) waveData2[i]=waveData2[i-addW.getNumSamples()];
  }
  for (i=0;i<addW.getNumSamples();i++)
  {
   waveData1[i+pos]=addW.waveData1[i];
   if (Channels==2)
    waveData2[i+pos]=addW.waveData2[i];
  }
  Size=NumSamples*bit/8*Channels;
 }
// addW.freemem();
// addW.setWloadStat( 0 );
}

void Wave::fadeIn( int startp, int endp, int perc, int chann )
{
 int i;

 for (i=startp;i<endp;i++)
 {
  if ( chann==1 )
  waveData1[i]=int(waveData1[i]*((100-perc*(1-float(i-startp)/(endp-startp)))/100));
  else
  waveData2[i]=int(waveData2[i]*((100-perc*(1-float(i-startp)/(endp-startp)))/100));
 }
}

void Wave::fadeOut( int startp, int endp, int perc, int chann )
{
 int i;

 for (i=startp;i<=endp;i++)
 {
  if ( chann==1 )
   waveData1[i]=int(waveData1[i]*((100-perc*float(i-startp)/(endp-startp))/100));
  else
   waveData2[i]=int(waveData2[i]*((100-perc*float(i-startp)/(endp-startp))/100));
 }
}

int Wave::initPlay()
{

 dsp_samplesize = 16;
 dsp_speed = Sampling;
 dsp_stereo = Channels-1;
 buffer_size = 256;
 audio_dev = "/dev/dsp";

 audio = open (audio_dev, O_WRONLY, 0);
 if(audio == -1) 
 {
  return -1;
 }
 if(ioctl(audio,SNDCTL_DSP_SPEED,&dsp_speed) == -1)
 {
  close(audio);
  audio = -1;
  return -2;
 }
 if(ioctl(audio,SNDCTL_DSP_SAMPLESIZE,&dsp_samplesize) == -1)
 {
  close(audio);
  audio = -1;
  return -3;
 }
 if(ioctl(audio,SNDCTL_DSP_STEREO,&dsp_stereo) == -1)
 {
  close(audio);
  audio = -1;
  return -4;
 }
 ioctl(audio,SNDCTL_DSP_GETBLKSIZE,&buffer_size);
 if((buffer = (short*) malloc(buffer_size)) == NULL)
 {
  close(audio);
  audio = -1;
  return -4;
 }
 currPlayPos=0;
 playActive=1;
 return 0;
}

void Wave::play()
{
 int i;

 if (currPlayPos < Channels*NumSamples/(buffer_size/2))
 {
  if(dsp_stereo==1) 
  {
   for(i = 0;i < buffer_size/4;i++)
   {
    buffer[i * 2] = waveData1[currPlayPos*buffer_size/4+i];
    buffer[i * 2 + 1] = waveData2[currPlayPos*buffer_size/4+i];
   }
  }
  else 
  for(i = 0;i < buffer_size/2;i++)
  buffer[i] = waveData1[currPlayPos*buffer_size/2+i];
  currPlayPos++;
  if(write(audio,buffer,buffer_size) != buffer_size)
  {
   stopPlay();
  }
 }
 else
 {
  stopPlay();
 }
}

void Wave::stopPlay()
{
 currPlayPos=0;
 m->timer->stop();
 close(audio);
 audio = -1;
 free(buffer);
 playActive=0; 
 m->initPlayMenu();
}

void Wave::pausePlay()
{
 m->timer->stop();
 playActive=0;
 m->initPlayMenu();
}

int Wave::getActivePlay()
{
 return playActive;
}

int Wave::getCurrPlayPos()
{
 return currPlayPos;
}

int Wave::getDSPBuffer()
{
 return buffer_size;
}
